Skip to content

Post

POST
/final-destination/v2

Query the Naurt Final Destination dataset to retrieve precise destination locations for addresses, buildings, entrances, and parking locations.

Each request contains one or more queries. A query can represent several different search types supported by the Final Destination API:

• Forward geocoding — supply an address_string or address_structured
• Reverse geocoding — supply a location with latitude and longitude
• Naurt ID lookup — supply an id returned from a previous query
• Source ID lookup — supply identifiers such as os_uprn

The API returns a best match for each query along with optional additional matches. Results may include multiple destination geometries such as building entrances, delivery doors, or parking locations depending on available data.

The geometry format returned by the API is controlled by options.geojson_type:

geojson (default) — results are returned as standard GeoJSON FeatureCollections with geometries and properties.

key_value — results are returned as a simplified key/value representation where each destination type contains latitude and longitude coordinates.

Each query result includes a status, the best match, optional additional matches, and metadata such as distance from the search location when applicable.

A single request to the API, which can contain up to 200 queries. Each query is independent and can be of a different type.

object
queries
required
Array<object>
>= 1 items <= 200 items

A single search query. It can be used to lookup a door and parking spot by:

  • Forward geocode
  • Reverse geocode
  • Structured geocode
  • Naurt ID lookup
  • Source ID lookup
object
address_string
string
address_structured

Naurt’s own format for structured address data. Please see: https://docs.naurt.com/reference/address-structure/ for significant more details on this data format.

When searching, do not use country_code - as it is not used. country_code is for responses only.

object
unit
string
house_name
string
street_number
string
street_name
string
locality
string
city
string
county
string
state
string
country
string
postalcode
string
country_code

An enum representing all possible countries that Naurt currently supports

string
Allowed values: AE AU AT BE BH BR CA CH CZ DE EG ES FI FR GB GG HK IE IM IT JE JO JP KR LU NL NO NZ PL PT QA SA SE SI SG TW US UK ZA
location

A location, using WGS84 latitude and longitude.

Used for a reverse geocode, or to add some location bias to a forward geocode.

Use distance_filter to optionally limit the distance from this point that results can appear within

object
latitude
required
number
>= -90 <= 90
longitude
required
number
>= -180 < 180
distance_filter
number
default: 5000 > 0 <= 25000
id
string format: uuid
country

An enum representing all possible countries that Naurt currently supports

string
Allowed values: AE AU AT BE BH BR CA CH CZ DE EG ES FI FR GB GG HK IE IM IT JE JO JP KR LU NL NO NZ PL PT QA SA SE SI SG TW US UK ZA
source_id
object
>= 1 properties <= 1 properties
os_uprn
string
os_udprn
string
additional_matches
boolean
language

Used for reverse geocodes only, to decide which language the response is in. In a forward geocode, the response language will match the input language.

See: https://docs.naurt.com/reference/language/ for detailed information on language availability for all countries (not all countries have alternative languages)

string
default: Auto
Allowed values: Auto EN AR JA FR DE IT PT KO ZH NL NO FI PL SL CZ
options

options impact all queries within a request

object
pretty_print

This will format the response in a more human readable way. Only recommended for debug, as it increases payload size

boolean
verbose

Returns additional debug information about request processing. Only recommended for debug, as it increases payload size

boolean
structured_response

Adds the Naurt structured format of the address to the response

boolean
geojson_type

Use this to switch between a key-value style GeoJSON or a classic GeoJSON

string
default: geojson
Allowed values: geojson key_value
return_original

Returns your original query back in the response

boolean
input_filter

Input filtering helps when you have addresses from sources you can’t control. Sometimes, providers might miss out on important parts of addresses, like a street number or postcode. If Naurt detects that an address is missing too many fields to be likely to give a good match, it can be rejected by this feature

none turns this feature off and does not do any input filtering. This may result in some poor responses

loose is the default - it does filter out some poor inputs but allows some missing fields

strict is our strictest, and only allows searches which are likely to produce good matches

string
default: loose
Allowed values: none loose strict
Examples
{
"queries": [
{
"address_string": "32 Thames St, Windsor SL4 1PS",
"country": "GB"
}
]
}

Successful lookup

A response from the API. The responses are in the same order as the original queries from the request.

object
responses
required
Array<object>
object
best_match
required
One of:
Final Destination Hit
object
id
required
string format: uuid
address
required
string
geojson
required
One of:
object
features
required
Array<object>
>= 1 items <= 4 items
object
geometry
required
One of:
object
coordinates
required
Array<number>
>= 2 items <= 2 items
type
required
string
Allowed values: Point
properties
required
object
naurt_type
required
string
Allowed values: basic_geocode naurt_door naurt_building naurt_parking
accuracy
object
quality
required
string
Allowed values: low medium high
minimum_parking_to_door_distance
number format: double
type
required
string
Allowed values: Feature
type
required
string
default: FeatureCollection
Allowed values: FeatureCollection
distance
number
search_confidence

Confidence score in the range 0.0 to 1.0 indicating how well the result matches the query. Higher is better.

See: https://docs.naurt.com/reference/search-confidence

Not to be confused with Accuracy, which is how good the data itself is. This is about the likelihood of a good match.

number format: double
<= 1
Example
0.93
structured_response

Naurt’s own format for structured address data. Please see: https://docs.naurt.com/reference/address-structure/ for significant more details on this data format.

When searching, do not use country_code - as it is not used. country_code is for responses only.

object
unit
string
house_name
string
street_number
string
street_name
string
locality
string
city
string
county
string
state
string
country
string
postalcode
string
country_code

An enum representing all possible countries that Naurt currently supports

string
Allowed values: AE AU AT BE BH BR CA CH CZ DE EG ES FI FR GB GG HK IE IM IT JE JO JP KR LU NL NO NZ PL PT QA SA SE SI SG TW US UK ZA
source_id

An object containing information on source IDs. Source IDs refer to underlying IDs from address data sets. Currently supporting UPRN and UDPRN in the UK referring to the OrdnanceSurvey datasets

object
os_uprn
string
os_udprn
string
Example
{
"UPRN": {
"value": {
"os_uprn": "100062664604"
}
},
"UDPRN": {
"value": {
"os_udprn": "25962203"
}
}
}
additional_matches
required
Array<object>
Final Destination Hit
object
id
required
string format: uuid
address
required
string
geojson
required
One of:
object
features
required
Array<object>
>= 1 items <= 4 items
object
geometry
required
One of:
object
coordinates
required
Array<number>
>= 2 items <= 2 items
type
required
string
Allowed values: Point
properties
required
object
naurt_type
required
string
Allowed values: basic_geocode naurt_door naurt_building naurt_parking
accuracy
object
quality
required
string
Allowed values: low medium high
minimum_parking_to_door_distance
number format: double
type
required
string
Allowed values: Feature
type
required
string
default: FeatureCollection
Allowed values: FeatureCollection
distance
number
search_confidence

Confidence score in the range 0.0 to 1.0 indicating how well the result matches the query. Higher is better.

See: https://docs.naurt.com/reference/search-confidence

Not to be confused with Accuracy, which is how good the data itself is. This is about the likelihood of a good match.

number format: double
<= 1
Example
0.93
structured_response

Naurt’s own format for structured address data. Please see: https://docs.naurt.com/reference/address-structure/ for significant more details on this data format.

When searching, do not use country_code - as it is not used. country_code is for responses only.

object
unit
string
house_name
string
street_number
string
street_name
string
locality
string
city
string
county
string
state
string
country
string
postalcode
string
country_code

An enum representing all possible countries that Naurt currently supports

string
Allowed values: AE AU AT BE BH BR CA CH CZ DE EG ES FI FR GB GG HK IE IM IT JE JO JP KR LU NL NO NZ PL PT QA SA SE SI SG TW US UK ZA
source_id

An object containing information on source IDs. Source IDs refer to underlying IDs from address data sets. Currently supporting UPRN and UDPRN in the UK referring to the OrdnanceSurvey datasets

object
os_uprn
string
os_udprn
string
Example
{
"UPRN": {
"value": {
"os_uprn": "100062664604"
}
},
"UDPRN": {
"value": {
"os_udprn": "25962203"
}
}
}
status
required

The queries and responses arrays are always 1:1. If no match can be found, a 404 will NOT be returned. Instead, check this enum for no_matches. That indicates no error has happened, but nothing was found. ok when something is found.

string
Allowed values: ok no_matches
original_request

A single search query. It can be used to lookup a door and parking spot by:

  • Forward geocode
  • Reverse geocode
  • Structured geocode
  • Naurt ID lookup
  • Source ID lookup
object
address_string
string
address_structured

Naurt’s own format for structured address data. Please see: https://docs.naurt.com/reference/address-structure/ for significant more details on this data format.

When searching, do not use country_code - as it is not used. country_code is for responses only.

object
unit
string
house_name
string
street_number
string
street_name
string
locality
string
city
string
county
string
state
string
country
string
postalcode
string
country_code

An enum representing all possible countries that Naurt currently supports

string
Allowed values: AE AU AT BE BH BR CA CH CZ DE EG ES FI FR GB GG HK IE IM IT JE JO JP KR LU NL NO NZ PL PT QA SA SE SI SG TW US UK ZA
location

A location, using WGS84 latitude and longitude.

Used for a reverse geocode, or to add some location bias to a forward geocode.

Use distance_filter to optionally limit the distance from this point that results can appear within

object
latitude
required
number
>= -90 <= 90
longitude
required
number
>= -180 < 180
distance_filter
number
default: 5000 > 0 <= 25000
id
string format: uuid
country

An enum representing all possible countries that Naurt currently supports

string
Allowed values: AE AU AT BE BH BR CA CH CZ DE EG ES FI FR GB GG HK IE IM IT JE JO JP KR LU NL NO NZ PL PT QA SA SE SI SG TW US UK ZA
source_id
object
>= 1 properties <= 1 properties
os_uprn
string
os_udprn
string
additional_matches
boolean
language

Used for reverse geocodes only, to decide which language the response is in. In a forward geocode, the response language will match the input language.

See: https://docs.naurt.com/reference/language/ for detailed information on language availability for all countries (not all countries have alternative languages)

string
default: Auto
Allowed values: Auto EN AR JA FR DE IT PT KO ZH NL NO FI PL SL CZ
logging
object
info
Array<string>
warnings
Array<string>
errors
Array<string>
version
required
string
request_id
required
string format: uuid
Examples
{
"request_id": "96becf25-e233-4f9c-a05c-4bed90190bdd",
"version": "v2",
"responses": [
{
"status": "ok",
"best_match": {
"id": "c56dbebb-c7ab-ede2-a7ac-f84e57d1878d",
"address": "11600 NW 14th St, Hollywood, FL 33026-2568, United States",
"geojson": {
"type": "FeatureCollection",
"features": [
{
"type": "Feature",
"geometry": {
"type": "Point",
"coordinates": [
-80.305321,
26.019775
]
},
"properties": {
"naurt_type": "basic_geocode"
}
}
]
}
},
"additional_matches": []
}
]
}

Bad request or validation errors

All Naurt errors come in this standard format.

code is a unique error code you can quote to support, should you need to

reason explains why this error has been received

remediation gives steps to help resolve this error

object
code
required
string
reason
required
string
remediation
required
string

Internal server errors

All Naurt errors come in this standard format.

code is a unique error code you can quote to support, should you need to

reason explains why this error has been received

remediation gives steps to help resolve this error

object
code
required
string
reason
required
string
remediation
required
string